'use strict';

function onPlayerJoin(player) {
	player.allowPowerSliding = true;

	gm.utility.broadcastMessage(gm.chat.colors.dimgrey, '* ' + player.name + ' has joined the server.');
	gm.useraccounts.addPlayer(player);
	gm.chatsystem.onPlayerJoin(player);

	gm.chat.send(player,gm.chat.colors.darkgreen, 'Welcome to Bully Freeroam use /cmds for a list of commands!');

	var modelId = data.playerModels[Math.floor(Math.random() * data.playerModels.length)].modelId;
	while(!gm.utility.isValidModelIndex(modelId)) {
		modelId = data.playerModels[Math.floor(Math.random() * data.playerModels.length)].modelId;
	}

	var spawn = gm.config.spawns[Math.floor(Math.random() * gm.config.spawns.length)];
	player.spawn(modelId, 0, spawn.position, spawn.heading);
}
bullymp.events.add("playerJoin", onPlayerJoin);

function onPlayerQuit(player, reason) {
	gm.utility.broadcastMessage(gm.chat.colors.dimgrey, '* ' + player.name + ' has left the server.');
}
bullymp.events.add("playerQuit", onPlayerQuit);

function onPlayerSpawn(player) {
	bullymp.events.callRemote(player, 'cameraFade', 1.0, false);
}
bullymp.events.add("playerSpawn", onPlayerSpawn);

function onPlayerKnockedOut(player, responsiblePlayer) {
	if(!!player) {
		if(!!responsiblePlayer) {
			gm.utility.broadcastMessage(gm.chat.colors.brown, '* ' + player.name + ' has been knocked out by ' + responsiblePlayer.name + '.');
		}
		else {
			gm.utility.broadcastMessage(gm.chat.colors.brown, '* ' + player.name + ' has been knocked out.');
		}
	}

	var spawn = gm.config.spawns[Math.floor(Math.random() * gm.config.spawns.length)];
	player.spawn(player.modelId, 0, spawn.position, spawn.heading);
}
bullymp.events.add("playerKnockedOut", onPlayerKnockedOut);
